searchNodes=[{"doc":"ClickHouse driver for Elixir. Ch uses HTTP interface and RowBinaryWithTypesAndNames format for all statements except for INSERT . In order to enable custom formats, INSERT statements require the parameters to be encoded prior to calling query/4 .","ref":"Ch.html","title":"Ch","type":"module"},{"doc":"Returns a supervisor child specification for a DBConnection pool.","ref":"Ch.html#child_spec/1","title":"Ch.child_spec/1","type":"function"},{"doc":"Runs a query and returns the result as {:ok, %Ch.Result{}} or {:error, %Ch.Error{}} if there was a database error. Options :timeout - Query request timeout :settings - Keyword list of settings :database - Database :username - Username :password - User password","ref":"Ch.html#query/4","title":"Ch.query/4","type":"function"},{"doc":"Runs a query and returns the result or raises Ch.Error if there was an error. See query/4 .","ref":"Ch.html#query!/4","title":"Ch.query!/4","type":"function"},{"doc":"Start the connection process and connect to ClickHouse. Options * ` :hostname ` - server hostname , defaults to ` localhost ` * ` :port ` - HTTP port , defualts to ` 8123 ` * ` :scheme ` - HTTP scheme , defaults to ` &quot;http&quot; ` * ` :database ` - Database , defaults to ` &quot;default&quot; ` * ` :username ` - Username * ` :password ` - User password * ` :settings ` - Keyword list of settings * ` :timeout ` - HTTP receive timeout in milliseconds","ref":"Ch.html#start_link/1","title":"Ch.start_link/1","type":"function"},{"doc":"Query struct wrapping the SQL statement.","ref":"Ch.Query.html","title":"Ch.Query","type":"module"},{"doc":"","ref":"Ch.Query.html#t:t/0","title":"Ch.Query.t/0","type":"type"},{"doc":"Result struct returned from any successful query. Its fields are: command - An atom of the query command, for example: :select , :insert ; rows - The result set. One of: a list of lists, each inner list corresponding to a row, each element in the inner list corresponds to a column; raw iodata when the response is not automatically decoded, e.g. x-clickhouse-format: CSV num_rows - The number of fetched or affected rows; meta - A map of metadata collected from the response headers like x-clickhouse-format , x-clickhouse-query-id , x-clickhouse-summary , etc.","ref":"Ch.Result.html","title":"Ch.Result","type":"module"},{"doc":"","ref":"Ch.Result.html#t:summary/0","title":"Ch.Result.summary/0","type":"type"},{"doc":"","ref":"Ch.Result.html#t:t/0","title":"Ch.Result.t/0","type":"type"},{"doc":"","ref":"Ch.Error.html","title":"Ch.Error","type":"exception"},{"doc":"","ref":"Ch.Error.html#exception/2","title":"Ch.Error.exception/2","type":"function"},{"doc":"","ref":"Ch.Error.html#t:t/0","title":"Ch.Error.t/0","type":"type"},{"doc":"ClickHouse driver for Elixir. Documentation: http://hexdocs.pm/ch/","ref":"readme.html","title":"Ch","type":"extras"},{"doc":"iex&gt; { :ok , pid } = Ch . start_link ( scheme : &quot;http&quot; , hostname : &quot;localhost&quot; , port : 8123 , database : &quot;default&quot; ) { :ok , # PID &lt; 0 . 269 . 0 &gt; } iex&gt; Ch . query! ( pid , &quot;SELECT number, number * 2 FROM system.numbers LIMIT 2&quot; ) % Ch.Result { command : :select , rows : [ [ 0 , 0 ] , [ 1 , 2 ] ] } iex&gt; Ch . query! ( pid , &quot;CREATE TABLE my_first_table (metric Float32) ENGINE = Memory&quot; ) % Ch.Result { command : :create , rows : [ ] } iex&gt; Ch . query! ( pid , &quot;INSERT INTO my_first_table VALUES (0), (1)&quot; ) % Ch.Result { command : :insert , num_rows : 2 }","ref":"readme.html#examples","title":"Ch - Examples","type":"extras"},{"doc":"native parameters in queries iex&gt; Ch . query! ( pid , &quot;SELECT {$0:String}, {$1:Int64}&quot; , [ &quot;hello&quot; , 123 ] ) % Ch.Result { command : :select , rows : [ [ &quot;hello&quot; , 123 ] ] } custom formats , default format for reads is RowBinaryWithNamesAndTypes iex&gt; Ch . query! ( pid , &quot;SELECT 1, &#39;text&#39; FORMAT CSVWithNames&quot; ) % Ch.Result { command : :select , rows : [ &quot; \\&quot; 1 \\&quot; , \\&quot; &#39;text&#39; \\&quot; \\n &quot; , &quot;1, \\&quot; text \\&quot; \\n &quot; ] } iex&gt; Ch . query! ( pid , &quot;SELECT 1, &#39;text&#39;&quot; , [ ] , format : &quot;CSVWithNames&quot; ) % Ch.Result { command : :select , rows : [ &quot; \\&quot; 1 \\&quot; , \\&quot; &#39;text&#39; \\&quot; \\n &quot; , &quot;1, \\&quot; text \\&quot; \\n &quot; ] } # equivalent to default iex&gt; Ch . query! ( pid , &quot;SELECT 1, &#39;text&#39;&quot; , [ ] , format : &quot;RowBinaryWithNamesAndTypes&quot; ) % Ch.Result { command : :select , rows : [ [ 1 , &quot;text&quot; ] ] } iex&gt; Ch . query! ( pid , &quot;SELECT 1, &#39;text&#39; FORMAT CSV&quot; , [ ] , format : &quot;RowBinaryWithNamesAndTypes&quot; ) % Ch.Result { command : :select , rows : [ &quot;1, \\&quot; text \\&quot; \\n &quot; ] } efficient RowBinary encoder iex&gt; rows = [ [ 1 ] , [ 2.0 ] , [ 0.0 ] ] iex&gt; types = [ :f32 ] iex&gt; data = Ch.RowBinary . encode_rows ( rows , types ) iex&gt; Ch . query! ( pid , &quot;INSERT INTO my_first_table (metric) FORMAT RowBinary&quot; , { :raw , data } ) % Ch.Result { command : :insert , num_rows : 3 } streaming inserts iex&gt; rows = Stream . repeatedly ( fn -&gt; [ :rand . uniform ( ) ] end ) |&gt; Stream . take ( 1000 ) iex&gt; types = [ :f32 ] iex&gt; stream = rows |&gt; Stream . chunk_every ( 100 ) |&gt; Stream . map ( fn chunk -&gt; Ch.RowBinary . encode_rows ( chunk , types ) end ) iex&gt; Ch . query! ( pid , &quot;INSERT INTO my_first_table (metric) FORMAT RowBinary&quot; , stream ) % Ch.Result { command : :insert , num_rows : 1000 } settings iex&gt; Ch . query ( pid , &quot;INSERT INTO my_first_table VALUES (0), (1)&quot; , [ ] , settings : [ readonly : 1 ] ) { :error , % Ch.Error { code : 164 , message : &quot;Code: 164. DB::Exception: default: Cannot execute query in readonly mode. (READONLY)&quot; } } iex&gt; Ch . query! ( pid , &quot;SHOW SETTINGS LIKE &#39;async_insert&#39;&quot; , [ ] , settings : [ async_insert : 1 ] ) % Ch.Result { command : :show , rows : [ [ &quot;async_insert&quot; , &quot;Bool&quot; , &quot;1&quot; ] ] }","ref":"readme.html#features","title":"Ch - Features","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"fixed: make Ch.Error public","ref":"changelog.html#v0-1-2-05-04-2023","title":"Changelog - v0.1.2 (05/04/2023)","type":"extras"},{"doc":"added: more docs","ref":"changelog.html#v0-1-1-05-04-2023","title":"Changelog - v0.1.1 (05/04/2023)","type":"extras"}]